<?php

use NCSU\Auth\Adapter\ShibAuthAdapter;
use NCSU\Auth\AuthService;
use NCSU\Auth\Exception\RuntimeException;
use NCSU\Auth\Http\Request;

if (! function_exists('ncstate_auth')) {
    /**
     * Authenticates a user using the suggested default authentication
     * adapter.
     *
     * @return string the authenticated user's username
     */
    function ncstate_auth()
    {
        $request = Request::createFromGlobals();

        $shibAuthAdapter = new ShibAuthAdapter($request);
        $service = new AuthService($shibAuthAdapter);

        $result = $service->authenticate();

        if (! $result->isValid()) {
            throw new RuntimeException('Failed to authenticate via Shibboleth.');
        }

        return $result->getIdentity();
    }
}